//
//  main.cpp
//  HW#802
//
//  Created by Tammy on 4/25/15.
//  Copyright (c) 2015 Tammy. All rights reserved.
//

#include <iostream>
using namespace std;
// define Randomizor class
class Randomizor{
public:
    int rand();
    void srand(int s);
    Randomizor(int in1, int in2, int in3);
private:
    int a, b, c, cur;
};
// constructor
Randomizor::Randomizor(int in1, int in2, int in3){
    a = in1;
    b = in2;
    c = in3;
    cur = 0;
}
// a function that will generate random numbers with an input seed
int Randomizor::rand(){
    cur = (a*cur+b)%c;
    return cur;
}
void Randomizor::srand(int s){
    cur = s;
}
// a funtion that will sort the generated random numbers and find the median
double findMedian(int a[]){
    // declare an array to store the sorted numbers and initialize it to -1
    int t[10000];
    for(int k=0; k<1000; k++){
        t[k] = -1;
    }
    // the sorted rank of the numbers
    int position = 0;
    // for every number in the array, it compares with every other number and find how many numbers are smaller than itself
    for(int i=0; i<1000; i++){
        for(int j=0; j<1000; j++){
            if(a[i]>a[j]){
                // if the compare number is smaller, than position + 1 (rank +1)
                position++;
            }
        }
        // if the position in t is unavailable, which means there are same numbers in the random numbers, position + 1
        while(t[position]!=-1){
            position++;
        }
        // find the available position
        t[position] = a[i];
        // set the position to zero and compare the next number again
        position = 0;
    }
    // calculate the median and return
    return static_cast<double>(t[499]+t[500])/2;
}

int main() {
    int a=0, b=0, c=0, m=0;
    cin >> a >> b >> c >> m;
    // construct a dynamic two dimensional array to store the m*1000 random numbers 
    int** seq = new int*[m];
    for(int d=0; d<m; d++){
        seq[d] = new int[1000];
    }
    // declare r with Randomizor class attributes
    Randomizor r(a,b,c);
    
    // declare an array to store the runs of every seed
    int* runArray = new int[m];
    // store the runs of each seed
    int run = 0;
    // store the median of each seed
    double median = 0.0;
    for(int i=0; i<m; i++){
        int s = 0;
        // read the seed
        cin >> s;
        r.srand(s);
        for(int k=0; k<1000; k++){
            // generate the random numbers
            seq[i][k] = r.rand();
        }
        // invoke findMedian function to find the median of an array of random numbers
        median = findMedian(seq[i]);
        
        // if there are numbers equal to median, the program will skip the number
        int skip = 0;
        // compare every number with median and compute the runs
        for(int z=1; z<1000; z++){
            if(seq[i][z]==median){
                skip++;
            }
            else if(seq[i][z]>median && seq[i][z-1-skip]<median){
                run++;
                skip = 0;
            }
            else if(seq[i][z]<median && seq[i][z-1-skip]>median){
                run++;
                skip = 0;
            }
            else{
                // if the numbers are both larger than median or both smaller than median
                skip = 0;
            }
        }
        runArray[i] = run+1;
        run = 0;
    }
    // print out the result
    cout << runArray[0];
    for(int p=1; p<m; p++){
        cout << " " <<runArray[p];
    }
    // release the space
    delete seq;
    return 0;
}
